﻿Barrel = LibStub("AceAddon-3.0"):NewAddon("Barrel", "AceConsole-3.0", "AceEvent-3.0")
local ldb = LibStub("LibDataBroker-1.1")
local db_icon = LibStub("LibDBIcon-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Barrel")
local options = {}

function Barrel:OnInitialize()
	self:Config()
	options = LibStub("AceConfigRegistry-3.0"):GetOptionsTable("Barrel", "dialog", "Barrel-0.1")
	self:RegisterChatCommand("br", "ChatCommand")
	self:RegisterChatCommand("barrel", "ChatCommand")
end

function Barrel:OnEnable()
	for name, dataobj in ldb:DataObjectIterator() do
		local named = "Barrel"..name
		if not self.db.profile[named] then
			self.db.profile[named] = {}
		end
		db_icon:Register("Barrel"..name, dataobj, self.db.profile[named])
	end
	ldb.RegisterCallback(self, "LibDataBroker_DataObjectCreated", "DataObjectCreated")
end

function Barrel:DataObjectCreated(event, name, dataobj)
	local named = "Barrel"..name
	if not self.db.profile[named] then
		self.db.profile[named] = {}
	end
	db_icon:Register("Barrel"..name, dataobj, self.db.profile[named])
end

function Barrel:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("Barrel")
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(Barrel, "br", "Barrel", input)
	end
end

function Barrel:SetMinimapButtonPosition(name, angle)
	local frame = "Barrel"..name
	self.db.profile[frame].minimapPos = angle
end

function Barrel:GetMinimapButtonPosition(name)
	local frame = "Barrel"..name
	return self.db.profile[frame].minimapPos
end

function Barrel:Show(name)
	local frame = "Barrel"..name
	self.db.profile[frame].Minimap:Show()
end

function Barrel:Hide(name)
	local frame = "Barrel"..name
	self.db.profile[frame].Minimap:Hide()
end

function Barrel:IsLocked()
	return --self.locked
end

function Barrel:IsLauncher(dataobj)
	return dataobj.type == 'launcher'
end

-- Copyright 2008 Copystring"
